//PolicePistol.cs

datablock AudioProfile(PolicePistolFireSound)
{
	filename	 = "./police_pistol_fire.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(PolicePistolReloadSound)
{
	filename	 = "./police_pistol_reload.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(PolicePistolReload2Sound)
{
	filename	 = "./police_pistol_reload2.wav";
	description = AudioClose3d;
	preload = true;
};


//muzzle flash effects
datablock ParticleData(PolicePistolFlashParticle)
{
	dragCoefficient		= 3;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 25;
	lifetimeVarianceMS	= 15;
	textureName			 = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	  = "0.9 0.9 0.0 0.9";
	colors[1]	  = "0.9 0.5 0.0 0.0";
	sizes[0]		= 0.5;
	sizes[1]		= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PolicePistolFlashEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "PolicePistolFlashParticle";

};

datablock ParticleData(PolicePistolSmokeParticle)
{
	dragCoefficient		= 3;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 525;
	lifetimeVarianceMS	= 55;
	textureName			 = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	  = "0.5 0.5 0.5 0.9";
	colors[1]	  = "0.5 0.5 0.5 0.0";
	sizes[0]		= 0.15;
	sizes[1]		= 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PolicePistolSmokeEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "PolicePistolSmokeParticle";

};


datablock ParticleData(PolicePistolExplosionParticle)
{
	dragCoefficient		= 8;
	gravityCoefficient	= 1;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 700;
	lifetimeVarianceMS	= 400;
	textureName			 = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]	  = "0.9 0.9 0.9 0.3";
	colors[1]	  = "0.9 0.5 0.6 0.0";
	sizes[0]		= 0.25;
	sizes[1]		= 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(PolicePistolExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 2;
	velocityVariance = 1.0;
	ejectionOffset	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "PolicePistolExplosionParticle";

	useEmitterColors = true;
};


datablock ParticleData(PolicePistolExplosionRingParticle)
{
	dragCoefficient		= 8;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.2;
	constantAcceleration = 0.0;
	lifetimeMS			  = 50;
	lifetimeVarianceMS	= 35;
	textureName			 = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	  = "1 1 0.0 0.9";
	colors[1]	  = "0.9 0.0 0.0 0.0";
	sizes[0]		= 1;
	sizes[1]		= 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PolicePistolExplosionRingEmitter)
{
	lifeTimeMS = 50;

	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "PolicePistolExplosionRingParticle";

	useEmitterColors = true;
};

datablock ExplosionData(PolicePistolExplosion)
{
	//explosionShape = "";
	soundProfile = bulletHitSound;

	lifeTimeMS = 150;

	particleEmitter = PolicePistolExplosionEmitter;
	particleDensity = 5;
	particleRadius = 0.2;

	emitter[0] = PolicePistolExplosionRingEmitter;

	faceViewer	  = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;

	// Dynamic light
	lightStartRadius = 2;
	lightEndRadius = 2;
	lightStartColor = "0.9 0.9 0.2";
	lightEndColor = "0 0 0";
};


AddDamageType("PolicePistol",	'<bitmap:add-ons/Weapon_PolicePistol/CI_PolicePistol> %1',	 '%2 <bitmap:add-ons/Weapon_PolicePistol/CI_PolicePistol> %1',0.2,1);
AddDamageType("PolicePistolHeadshot",	'<bitmap:add-ons/Weapon_PolicePistol/CI_PolicePistol> %1',	 '%2 <bitmap:add-ons/Weapon_PolicePistol/CI_PolicePistol> %1',0.2,1);

datablock ProjectileData(PolicePistolProjectile)
{
	projectileShapeName = "./bullet.dts";
	directDamage		  = 30;
	directDamageType	 = $DamageType::PolicePistol;
	radiusDamageType	 = $DamageType::PolicePistol;

	brickExplosionRadius = 0;
	brickExplosionImpact = false;
	brickExplosionForce  = 0;
	brickExplosionMaxVolume = 0;
	brickExplosionMaxVolumeFloating = 0;  

	impactImpulse		  = 400;
	verticalImpulse	  = 400;
	explosion			  = PolicePistolExplosion;
	particleEmitter	  = ""; //bulletTrailEmitter;

	muzzleVelocity		= 150;
	velInheritFactor	 = 1;

	armingDelay			= 00;
	lifetime				= 4000;
	fadeDelay			  = 3500;
	bounceElasticity	 = 0.5;
	bounceFriction		= 0.20;
	isBallistic			= false;
	gravityMod = 0.0;

	hasLight	 = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
};

//item 
datablock ItemData(PolicePistolItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./police_pistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Police Pistol";
	iconName = "./icon_police_pistol";
	doColorShift = false;

	image = PolicePistolImage;
	canDrop = true;
};

//weapon image
datablock ShapeBaseImageData(PolicePistolImage)
{
	shapeFile = "./police_pistol.dts";
	emap = true;
	
	ammoType = "ammoType_revolver";

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; 
	rotation = eulerToMatrix( "0 0 0" );
	
	maxAmmo = 6;
	
	correctMuzzleVector = true;
	
	className = "WeaponImage";

	item = BowItem;
	ammo = " ";
	projectile = PolicePistolProjectile;
	projectileType = Projectile;

	melee = false;
	armReady = true;

	stateName[0]							= "Activate";
	stateTimeoutValue[0]				 = 0.15;
	stateTransitionOnTimeout[0]		 = "PreAmmoCheck";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]							= "Ready";
	stateTransitionOnNoAmmo[1]	= "PreReload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]			= true;
	stateSequence[1]	= "Ready";

	stateName[2]						  = "Fire";
	stateTransitionOnTimeout[2]	  = "Smoke";
	stateTimeoutValue[2]				= 0.14;
	stateFire[2]						  = true;
	stateAllowImageChange[2]		  = false;
	stateSequence[2]					 = "fire";
	stateScript[2]						= "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= PolicePistolFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= PolicePistolFireSound;

	stateName[3] = "Smoke";
	stateEmitter[3]					= PolicePistolSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]				= 0.05;
	stateTransitionOnTimeout[3]	  = "spin";

	stateName[4]			= "spin";
	stateSequence[4]					 = "reload"; //spin animation (called it reload for some reason lol)
	stateTransitionOnTimeout[4]	  = "PreAmmoCheck";
	stateTimeoutValue[4]				= 0.25;
	stateAllowImageChange[4]		  = false;
	stateWaitForTimeout[4]			= true;
	stateSound[4]					= PolicePistolReloadSound;
	
	stateName[5]                     = "PreAmmoCheck";
	stateTransitionOnTimeout[5]      = "AmmoCheck";
	stateTimeoutValue[5]             = 0;
	stateAllowImageChange[5]         = true;
	stateScript[5]         = "onPreAmmoCheck";
	
	stateName[6]	= "AmmoCheck";
	stateTransitionOnAmmo[6]	= "Ready";
	stateTransitionOnNoAmmo[6]	= "PreReload";
	stateAllowImageChange[6]	= false;
	
	stateName[7]	= "PreReload";
	stateWaitForTimeout[7]	= true;
	stateTransitionOnTimeout[7]	= "Reload";
	stateTimeoutValue[7]	= 0.2;
	
	stateName[8]	= "Reload";
	stateWaitForTiemout[8]	= true;
	stateScript[8]	= "onReload";
	stateTransitionOnTimeout[8]	= "ReloadDone";
	stateTimeoutValue[8] = 1.6;
	stateAllowImageChange[8]	= false;
	
	stateName[9]	= "ReloadDone";
	stateSound[9]	= PolicePistolReloadSound;
	stateWaitForTimeout[9]	= true;
	stateScript[9]	= "onReloadDone";
	stateTransitionOnTimeout[9] = "Ready";
	stateTimeoutValue[9]	= 0.2;

};

function PolicePistolImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	{
		%obj.playThread(2, shiftLeft);
		%obj.playThread(0, shiftRight); 
		
		%obj.ammoType_revolver -= 1;
		
		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Revolver Ammo:" SPC %obj.ammoType_revolver @ "/" @ %this.maxAmmo, 1, 0);
		
		if(%obj.ammoType_revolver < 1)
			%obj.setImageAmmo(%slot, 0);
	}

	Parent::onFire(%this,%obj,%slot);	
}

function PolicePistolImage::onPreAmmoCheck(%this,%obj,%slot)
{
	if(%obj.ammoType_revolver < 1)
		%obj.setImageAmmo(%slot, 0);
}

function PolicePistolImage::onReload(%this,%obj,%slot)
{
	if(%obj.ammoType_revolver == "")
		%obj.ammoType_revolver = 0;
	
	if(%obj.ammoType_revolver > 0)
		%obj.ammoType_revolver = 0;
	
	for(%i = 0; %i < %this.maxAmmo; %i++)
	{
		schedule(260*%i,0,serverPlay3D,PolicePistolReload2Sound,%obj.getPosition());
		%obj.schedule(260*%i, playThread, 2, shiftRight);
		%obj.ammoType_revolver += 1;
		schedule(260*%i,0,commandToClient,%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Revolver Ammo:" SPC %obj.ammoType_revolver @ "/" @ %this.maxAmmo, 1, 0);
	}
}

function PolicePistolImage::onReloadDone(%this,%obj,%slot)
{
	%obj.setImageAmmo(%slot, 1);
	
	%obj.playThread(0, plant);
}

function PolicePistolProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
	{
		if(%col.getClassName() $= "AIPlayer")
		{
			%oClient = %col.client;
			%col.client = BotConnection;
			%hitbox = getHitbox(%obj,%col,%pos);
			%col.client = %oClient;
		}
		else
		{
			%hitbox = getHitbox(%obj,%col,%pos);
		}		

	
		if(strstr(%hitbox, "headskin") > -1)
		{
			%col.damage(%obj,%pos,75,$DamageType::PolicePistolHeadshot);
			
			%colscale = getWord(%col.getScale(),2);
			
			%col.spawnExplosion(critProjectile,%colscale);
			
			if(isObject(%col.client))
				%col.client.play2d(critRecieveSound);
      
			if(isObject(%obj.client))
				%obj.client.play2d(critHitSound);
		}
		else
		{
			parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
		}
	}
	else
	{
		parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
	}
}

package RevolverLoading
{
	function servercmdLight(%client)
	{
		if(isObject(%client.player) && isObject(%client.player.getMountedImage(0)))
		{
			%p = %client.player;
			%o = %client.obj;
			%im = %p.getMountedImage(0);
			
			if(%im.maxAmmo > 0 && %p.ammoType_revolver < %im.maxAmmo)
			{
				if(%p.getImageState(0) $= "Ready")
					%p.setImageAmmo(0,0);
				return;
			}
		}
		
		Parent::servercmdLight(%client);
	}
};
activatePackage(RevolverLoading);